unit AlphaBlend_06;

// alpha blended zoom demo by odissey1
//
// uses TAlphaZoomTool class in unit AlphaZoom.pas
//

{
//For unlimited mouse drug (Panning outside ChartRect with mouse, you need correct Chart.pas


unit Chart.pas (TeeChart v7.12)

procedure TCustomChart.MouseMove(Shift: TShiftState; X, Y: Integer);
  ...
Begin
  ...
  With IPanning do // scroll
  if Active then
  Begin

//XXX    if PointInRect(ChartRect,x,y) then //disable to allow panning with mouse outside chartRect
//XXX    Begin

      if (x<>X1) or (y<>Y1) then
       Begin
        Panned:=False;
//XXX        Check; // Have no idea what it is doing here, but it causing double speed scroll

        if RestoredAxisScales then
        begin
          FSavedScales:=SaveScales;
          RestoredAxisScales:=False;
        end;

        PanAxis(True,X,X1);
        PanAxis(False,Y,Y1);
        X1:=x;
        Y1:=y;

        if Panned then
        Begin
          if Assigned(FOnScroll) then
             FOnScroll(Self);

          Invalidate;
        end;

      End;

//XXX    end
//XXX    else IPanning.Active:=False;
  end
  else
  if not CheckMouseSeries(x,y) then // is mouse not over Series ?
     Cursor:=OriginalCursor; // change back original cursor
end;
}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShellCtrls, Buttons, Spin
  , TeeEdit, TeEngine, Series, ExtCtrls, TeeProcs, Chart, TeeEditPro
  , BubbleCh, TeeSurfa, TeeMapSeries, TeePenDlg, TeCanvas
  , AlphaZoom //TAlphaZoomTool
  ;


type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    ChartEditor1: TChartEditor;
    Chart2: TChart;
    Series2: TLineSeries;
    Splitter1: TSplitter;
    Panel1: TPanel;
    CheckBoxAllowZoom: TCheckBox;
    Memo1: TMemo;
    CheckBoxBackgrOnly: TCheckBox;
    CheckBoxSkipSeries: TCheckBox;
    SpeedButtonEditChart2: TSpeedButton;
    SpeedButtonEditChart1: TSpeedButton;
    CheckBoxShowLog: TCheckBox;
    SpinEditBlendFactor: TSpinEdit;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    CheckBoxReverseButtons: TCheckBox;
    Series3: TBubbleSeries;
    Series4: TBubbleSeries;
    CheckBoxAllowScroll: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure CheckBoxAllowZoomClick(Sender: TObject);
    procedure CheckBoxBackgrOnlyClick(Sender: TObject);
    procedure CheckBoxSkipSeriesClick(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
    procedure Chart1UndoZoom(Sender: TObject);
    procedure SpeedButtonEditChart1Click(Sender: TObject);
    procedure CheckBoxShowLogClick(Sender: TObject);
    procedure SpinEditBlendFactorChange(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBoxReverseButtonsClick(Sender: TObject);
    procedure CheckBoxAllowScrollClick(Sender: TObject);
  private
    { Private declarations }
    AlphaZoomTool: TAlphaZoomTool;
    procedure Chart1Scrolled(Sender: TObject);
  public
    { Public declarations }
    procedure Log(s: string);
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
     Memo1.Clear;
     Memo1.Align:=alRight;
     Chart1.Align:=alLeft;
     Splitter1.Align:=alLeft;
     Chart2.Align:=alClient;

     Chart1.DoubleBuffered:=True;//only to avoid SpeedButton1 flicker, no effect on zoom/pan
     Chart2.DoubleBuffered:=True;//only to avoid SpeedButton2 flicker, no effect on zoom/pan

     AlphaZoomTool:=TAlphaZoomTool.Create(Chart1);
     AlphaZoomTool.CursorZoom:=crDrag;
     AlphaZoomTool.CursorPan:=crTeeHand;

     //new onScrolled event->
     TChart(Chart1).OnScrolled:=Chart1Scrolled;

//     Chart2.Zoom.Assign(Chart1.Zoom);
//     Chart2.Zoom.Brush.Color:=RGB(217, 236, 255);//
     Chart2.Zoom.Brush.Color:=clNone;
     Chart2.Zoom.Brush.Style:=bsSolid;

     Series3.FillSampleValues(10);
     Series1.FillSampleValues(20);

     Series2.Assign(Series1);
     Series4.Assign(Series3);


     TeeFillCursors(TComboFlat(ComboBox1), AlphaZoomTool.CursorZoom);
     TeeFillCursors(TComboFlat(ComboBox2), AlphaZoomTool.CursorPan);
     CheckBoxShowLog.Checked:=Memo1.Visible;
     SpinEditBlendFactor.Value:=AlphaZoomTool.BlendFactor;
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin
     AlphaZoomTool.Free;
end;


//decorations->

procedure TForm1.FormResize(Sender: TObject);
begin
     if Memo1.Visible then
       Chart1.Width:=(Form1.ClientWidth - Splitter1.Width - Memo1.Width) div 2
     else
       Chart1.Width:=(Form1.ClientWidth - Splitter1.Width) div 2;
end;

procedure TForm1.Log(s: string);
begin
     Memo1.Lines.Add(s);
end;

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
     ChartEditor1.Chart:=Sender as TChart;
     ChartEditor1.Execute;
end;
procedure TForm1.CheckBoxAllowZoomClick(Sender: TObject);
begin
     Chart1.AllowZoom:=(Sender as TCheckBox).Checked;
end;
procedure TForm1.CheckBoxAllowScrollClick(Sender: TObject);
begin
     if (Sender as TCheckBox).Checked then Chart1.AllowPanning:=pmBoth
                                      else Chart1.AllowPanning:=pmNone;
end;

procedure TForm1.CheckBoxBackgrOnlyClick(Sender: TObject);
begin
     AlphaZoomTool.BackgrOnly:=(Sender as TCheckBox).Checked;
end;

procedure TForm1.CheckBoxReverseButtonsClick(Sender: TObject);
begin
     if TCheckBox(Sender).Checked then begin
       Chart1.Zoom.MouseButton :=mbRight; Chart1.ScrollMouseButton:=mbLeft;
     end
     else begin
       Chart1.Zoom.MouseButton :=mbLeft; Chart1.ScrollMouseButton:=mbRight;
     end;
end;

procedure TForm1.CheckBoxSkipSeriesClick(Sender: TObject);
begin
     AlphaZoomTool.SkipSeries:=(Sender as TCheckBox).Checked;
end;


procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     AlphaZoomTool.CursorZoom := TeeSetCursor(crDefault, TComboBox(Sender).Text );
end;
procedure TForm1.ComboBox2Change(Sender: TObject);
begin
     AlphaZoomTool.CursorPan := TeeSetCursor(crDefault, TComboBox(Sender).Text );
end;

procedure TForm1.SpinEditBlendFactorChange(Sender: TObject);
begin
     AlphaZoomTool.BlendFactor:=(Sender as TSpinEdit).Value;
end;

procedure TForm1.SpeedButtonEditChart1Click(Sender: TObject);
begin
     ChartEditor1.Chart:=TChart((Sender as TSpeedButton).Parent);
     ChartEditor1.Execute;
end;

procedure TForm1.CheckBoxShowLogClick(Sender: TObject);
begin
     Memo1.Visible:=(Sender as TCheckBox).Checked;
     FormResize(Self);
end;

procedure TForm1.Chart1Zoom(Sender: TObject);
begin
     log('Zoom');
end;
procedure TForm1.Chart1UndoZoom(Sender: TObject);
begin
     log('UndoZoom');
end;
procedure TForm1.Chart1Scrolled(Sender: TObject);
begin
     log('Scrolled');
end;
end.


{
Zoom

1. Zoom rectangle painted using pmNotXor method, looks quite unpleasant on a grainy background. Frame Color is unpredicable on complex bitmap
   background. Can we have selection rectangle, similar to standard Windows Explore? It should have regular color frame with pmCopy method,
   blended background and standard Windows selection color (clHighlight)?

2. Other problem is that Zoom Rectangle shows considerable flicker when zooming, especially on large screens, and when Pen.Width is large.

3. ZoomRectangle->Pen.Width limited to 6 pixels (probably due to considerable flicker discussed above). Can we increase this number to 10-20?

4. Default Zoom Frame PenMode is 'round', can we have default setting as 'flat' (especially for pen.Width>1)?

5. Default Zoom Buton is mbLeft, which is odd. It is custom in most packages nowadays to use left button for scrolling (e.g. Google maps).

6. Possibility of having custom ZoomCursor

Scroll

1. Default Scroll with Right mouse is defective, scrolling stops when mouse leaves ChartRect. This is odd and unnecessary feature. For example Google
    Maps can be dragged outside of the panel boundaries.

2. Standard behaviour of the Left and Right mouse buttons in Windows is slightly different (Right mouse is slightly deficient, so that MouseUp event is not
    fired outside of the Application Form). As a result, simple swapping Left and Right mouse buttons in TChart breakes functionality of the Chart Zoom and
    Pan. For example, trying to Zoom with Right mouse outside the ChartRect freezes Zoom event. Wishlist: make Left and Right buttons equivalent, so that
    one could swap Zooming/Panning buttons easyly.

3. Chart onScrolled (end of Scroll) event does not exist. It is very important to have this event to be able synchronize/update chart when amount of
   data points is large (and updating onScrolling is not an option).

4. Possibility of having custom ScrollCursor}
